#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <apc/ir.h>
#include <unistd.h>

struct cdat*
alloc_cdat(void);
struct odat*
alloc_odat(void);
void
alloc_vdat(void);
struct link*
alloc_link(void);
struct ref*
alloc_ref(void);
struct cdat*
curr_cdat(void);
struct odat*
curr_odat(void);
struct vdat*
curr_vdat(void);
struct ele*
curr_ele(void);
struct set*
curr_set(void);
struct ref*
prev_ref(void);
struct model
curr_model(void);
void
inc_posts(void);

#define CURR_CDAT (*cdat_stackp)
#define CURR_SET set_list[CURR_CDAT->num_sets]
#define CURR_ELE ele_list[CURR_CDAT->CURR_SET.num_ele]
#define PREV_REF (ref_buf[num_refs-1])
#define CURR_REF (ref_buf[num_refs])
#define PREV_ODAT (odat_buf[num_odats-1])
#define CURR_ODAT (odat_buf[num_odats])
#define CURR_VDAT (vdat_buf[num_vdats])
#define PREV_VDAT (vdat_buf[num_vdats-1])
#define CURR_MODEL (CURR_VDAT->model_list[CURR_VDAT->num_models])
#define CURR_LINK (link_buf[num_links])
#define CURR_POST (post_buf[num_posts])
#define CURR_QUAD (CURR_ODAT->quad_file)


int num_cdats = 0;
int curr_max_cdats = PTRS_IN_PAGE;

struct cdat* cdat_buf[PTRS_IN_PAGE];
struct cdat* cdat_stack[PTRS_IN_PAGE];
struct cdat** cdat_stackp;


int num_odats = -1;
int curr_max_odats = PTRS_IN_PAGE;
struct odat* odat_buf[PTRS_IN_PAGE];


int num_vdats = -1;
int curr_max_vdats = PTRS_IN_PAGE;
struct vdat* vdat_buf[PTRS_IN_PAGE];


int num_refs = -1;
int curr_max_refs = PTRS_IN_PAGE;
struct ref* ref_buf[PTRS_IN_PAGE];
uint64_t ss_ref_id = 0x00FFFFFF; /* system space for ref_ids */

int num_posts = -1;
int curr_max_posts = PTRS_IN_PAGE;
struct ref* post_buf[PTRS_IN_PAGE];


int num_links = -1;
int curr_max_links = PTRS_IN_PAGE;
struct link* link_buf[PTRS_IN_PAGE];


/* The initalization function of the IR. */
int
ir_init()
{

  /* Init root cdat and stack */
  char root[4] = "root";

  if( (cdat_buf[num_cdats] = (struct cdat*) malloc(sizeof(struct cdat))) == NULL)
    {
      perror("malloc root class failed\n");
      return -1;
    }
  cdat_buf[num_cdats]->idx = num_cdats;
  memmove(cdat_buf[num_cdats]->name, root, 4);

  cdat_stackp = cdat_stack;
  *cdat_stackp++ = cdat_buf[num_cdats++];

    return 0;

}

void
ir_quit()
{
  int i;

  for(i = 0; i <= num_odats ; i++)
    {
      free(odat_buf[i]);
    }
  for(i = 0; i <= num_cdats; i++)
    {
      free(cdat_buf[i]);
    }
  for(i = 0; i <= num_vdats; i++)
    {
      free(vdat_buf[i]);
    }
  for(i = 0; i <= num_refs; i++)
    {
      free(ref_buf[i]);
    }
  for(i = 0; i<= num_links; i++)
    {
      free(link_buf[i]);
    }

}

//TODO: FREE MEMORY!
struct cdat*
alloc_cdat()
{
  num_cdats++;
  if(curr_max_cdats <= num_cdats)
    { if( (realloc((void*) cdat_buf, PTRS_IN_PAGE * 4)) == NULL)
        perror("realloc cdat_buf failed");
      curr_max_cdats += PTRS_IN_PAGE;
      if( (realloc( (void*) cdat_stack, PTRS_IN_PAGE * 4)) == NULL) //increase cdat_stack also
        perror("realloc cdat_stack failed");
    }
  if( (CURR_CDAT = (struct cdat*) malloc(sizeof (struct cdat)) ) == NULL )
    perror("malloc cdat failed");

  return CURR_CDAT;

}
struct odat*
alloc_odat
()
{

  num_odats++;
  if(num_odats >= curr_max_odats)
    { if( (realloc((void*) odat_buf, PTRS_IN_PAGE * 4)) == NULL)
        perror("realloc odat_buf failed");
      curr_max_odats += PTRS_IN_PAGE;
    }
  if( (CURR_ODAT = (struct odat*) malloc(sizeof (struct odat))) == NULL)
    perror("malloc odat failed");

  return CURR_ODAT;
}

void
alloc_vdat
()
{
  num_vdats++;
  if(num_vdats >= curr_max_vdats)
    { if( (realloc((void*) vdat_buf, PTRS_IN_PAGE * 4)) == NULL)
        perror("realloc vdat_buf failed");
      curr_max_vdats += PTRS_IN_PAGE;
    }
  if((CURR_VDAT = (struct vdat*) malloc(sizeof (struct vdat))) == NULL)
     perror("malloc vdat failed");

}

struct link*
alloc_link
()
{
  num_links++;

  if(num_links >= curr_max_links)
    { if( (realloc((void*) link_buf, PTRS_IN_PAGE * 4)) == NULL)
        perror("realloc vdat_buf failed");
      curr_max_links += PTRS_IN_PAGE;
    }
  if((CURR_LINK = (struct link*) malloc(sizeof (struct link))) == NULL)
      perror("malloc link failed");

  return CURR_LINK;
}

struct ref*
alloc_ref
()
{
  num_refs++;

  if(num_refs % 16 == 0)
    { CURR_POST = CURR_REF;
      inc_posts();
    }

  if(num_refs >= curr_max_refs)
    { if( (realloc((void*) ref_buf, PTRS_IN_PAGE * 4)) == NULL)
        perror("realloc ref_buf failed");
      curr_max_refs += PTRS_IN_PAGE;
    }
  if((CURR_REF = (struct ref*) malloc(sizeof (struct ref))) == NULL)
    perror("malloc ref failed");

  return CURR_REF;
}

void
inc_posts()
{
  if(num_posts >= curr_max_posts)
    { if( (realloc((void*) ref_buf, PTRS_IN_PAGE * 4)) == NULL)
        perror("realoc post_buf failed");
      curr_max_posts += PTRS_IN_PAGE;
    }
  if ((CURR_POST = (struct ref*) malloc (sizeof (struct ref))) == NULL)
    perror("malloc post failed");

}

struct cdat*
curr_cdat
()
{
  return CURR_CDAT;
}

struct odat*
curr_odat
()
{
  return CURR_ODAT;
}
struct vdat*
curr_vdat
()
{
  return CURR_VDAT;
}
struct set*
curr_set
()
{
  return &CURR_CDAT->CURR_SET;
}
struct ele*
curr_ele
()
{
  return &CURR_CDAT->CURR_SET.CURR_ELE;
}
struct ref*
prev_ref
()
{
  return PREV_REF;
}
struct model
curr_model
()
{
  return CURR_MODEL;
}
